function ChannelDataCtrl($http, $scope, $timeout, $location) {
	
	var getChannelData = function() {
		$http.get("abb_isapi.dll?cmd=channel_data" + '&' + new Date().getTime()).success(function(data, status, headers) {
			if($scope.validateJSONresponse(headers)){
				$scope.groups = data;
			}
		}).error(function(data) {});
	};
	
	getChannelData();
	
	$scope.clickedCD = true;
	
	$scope.acknowledge = function(alarm, channel) {
		$http({
	            url: 'abb_isapi.dll?cmd=ack_alarm&channelId='+channel.channelId+'&alarmTag='+alarm.tag,
	            method: "POST"
	        }).success(function(data) {
	        	getChannelData();
            	 if(!$scope.$$phase) {
            		 $scope.$apply();  
            	 }
			});
	};
	
	$scope.totalizerSet = function(totalizer, channel, status) {
		$http({
	            url: 'abb_isapi.dll?cmd=totalizer_set&channelId='+channel.channelId+"&totalizerId="+totalizer.totalizerId+"&command=" +status,
	            method: "POST"
	        }).success(function(data) {
	             getChannelData();
            	 if(!$scope.$$phase) {
            		 $scope.$apply();  
            	 }
			}); 
	};
	
	var stop = null;
	
	$scope.autoRefreshCD = function() {
     	if ($scope.clickedCD && $location.path() == "/channels") {
				getChannelData();
				stop = $timeout($scope.autoRefreshCD, config[0].value);
		}
		else {
	        $timeout.cancel(stop);     
		}
	};
	
	if ($scope.clickedCD) {
		stop = $timeout($scope.autoRefreshCD, config[0].value);
	}
	
}

function ConfigurationCtrl($scope, $http, $location, $window, $cookieStore) {
	if($cookieStore.get('username') == null || $cookieStore.get('role') != 2) {
		$location.path("#/home");
	}
	$scope.completed = "";
	$scope.auth = $cookieStore.get("authz");
	$scope.confExport = 
		function() {
			window.location.href = 'abb_isapi.dll?cmd=config_export&auth=' + $scope.auth;
			$scope.completed = "";
	};
	
	$scope.uploadComplete = function (content, completed) {
		$scope.completed = "";
    if (completed && content.length > 0) {
      if(JSON.parse(content).success)
      {
        $scope.InvalidFormat = "";
        $scope.completed = "Configuration has been successfully changed.";
      }
      else
      {
        $scope.InvalidFormat = "Error changing configuration";
        $scope.completed = "";
      }
    }
	};
}

function LoginController($rootScope, $scope, $http, $location, $cookieStore) {
	$rootScope.login = function(user) {
		var authz = 'Basic ' + Base64.encode(user.username + ':' + user.password);
		$http.defaults.headers.common['Authorization'] = authz;
		$http.get("abb_isapi.dll?cmd=authenticate").success(function(data, status, headers) {
			if($scope.validateJSONresponse(headers)){
				$cookieStore.put('authz', authz);
				$cookieStore.put('username', data.username);
				$cookieStore.put('role', data.role);
				location.reload();
			}
		}).error(function(data) {
			$rootScope.error = "Invalid username or password.";
			user.password = undefined;
		});
	};
}

function HomeCtrl($http, $scope, $timeout, $location) {
	 $http.get("abb_isapi.dll?cmd=device_info").success(function(data, status, headers) {
		 	$scope.deviceInfo = data;
		 	$('#operatorLabel').html(" <p><h4>" + $scope.deviceInfo.processGroups[0].group + " - " + $scope.deviceInfo.processGroups[0].views[0].view + "</h4></p>" );
		 	$scope.view = "abb_isapi.dll?cmd=operator_view&group="+ $scope.deviceInfo.processGroups[0].group  + "&" + $scope.deviceInfo.processGroups[0].views[0].viewCode; 
	 	}).error(function(data) {
	 });

	
	var stop = null;
	$scope.clicked = true;
	var fromOnChange = false;
	
	$scope.autoRefresh = function() {
		if ($scope.clicked && $location.path() == "/home") {
				 $http.get("abb_isapi.dll?cmd=device_info").success(function(data, status, headers) {
					 	$scope.deviceInfo = data;
					 	if(!$scope.$$phase) {
		            		 $scope.$apply();  
		            	}
				 	}).error(function(data) {
				 });
				 if(!fromOnChange) {
				$('#opImgResizable img').attr('src', $scope.view + '&' + new Date().getTime());
				 } else {
					 fromOnChange = false;
				 }
				stop = $timeout($scope.autoRefresh, config[0].value);
		}
		else {
	        $timeout.cancel(stop);   
		}
	};
	
	if ($scope.clicked) {
		stop = $timeout($scope.autoRefresh, config[0].value);
	}
	
	
	$("select").change(function() {
		fromOnChange = true;
		var groupName = "";
		var viewOpView = "";
		var viewCode = $(this).find('option:selected').val();
		var view = $(this).find('option:selected').text();
		if(view == "ChangeView") {
			return;
		}
		var group = $(this).find('option:selected').parent().attr("label");
		if(group !== undefined){
			groupName = $(this).find('option:selected').parent().attr("label");
			viewOpView = " - " + view;
		} else {
			viewOpView = view;
		}
		
		$('#operatorLabel').html("<p><h4>" + groupName + viewOpView + "</h4></p>" );
		$scope.view = 'abb_isapi.dll?cmd=operator_view&group=' + groupName.split(' ').join('') + '&view=' + viewCode.split(' ').join('');
		$('#opImgResizable img').attr('src', $scope.view + '&' + new Date().getTime());
    });
}


function InstrumentStatusCtrl($http, $scope) {
	$http.get("abb_isapi.dll?cmd=instrument_status").success(function(data, status, headers) {
		$scope.status = data;
	}).error(function(data) {});
}

function LogsCtrl($http, $scope) {
		$http.get("abb_isapi.dll?cmd=device_info").success(function(data, status, headers) {
				if(data.totalizersEnabled) {
					$http.get("abb_isapi.dll?cmd=totalizer_event_log").success(function(data, status, headers) {
						if($scope.validateJSONresponse(headers)){
							$scope.totalizerLogs = data;
						}
					}).error(function(data) {
					});
				}
				
				if(data.batch) {
					$http.get("abb_isapi.dll?cmd=batch_event_log").success(function(data, status, headers) {
						if($scope.validateJSONresponse(headers)){
							$scope.batchLogs = data;
						}
					}).error(function(data) {
					});
				}
			  }).error(function(data) {
		});
			
		$http.get("abb_isapi.dll?cmd=alarm_event_log").success(function(data, status, headers) {
			if($scope.validateJSONresponse(headers)){
				$scope.alarmLogs = data;
			}
		}).error(function(data) {
		});
	
		$http.get("abb_isapi.dll?cmd=audit_event_log").success(function(data, status, headers) {
			if($scope.validateJSONresponse(headers)){
				$scope.auditLogs = data;
			}
		}).error(function(data) {
		});
	
}

function MultiInstrumentCtrl() {
}

function OperatorMessageCtrl($http, $scope, $location, $cookieStore) {
	if($cookieStore.get('username') == null || $cookieStore.get('role') != 1 && $cookieStore.get('role') != 2) {
		$location.path("#/home");
	}
	$scope.opMsgGroups = {};
	$http.get("abb_isapi.dll?cmd=device_info").success(function(data, status, headers) {
		$scope.opMsgGroups = data.processGroups;
	  }).error(function(data) {
});
	
	$scope.selectedAll = false;
	
    $('#select-all').click(function (event) {
        var selected = this.checked;
        $(':checkbox').each(function () {
        	this.checked = selected; 
    	});
        $scope.selectedAll = true;
    });

    $scope.$watch('groups', function(newVal, oldVal) {
        $scope.selectedAll = false;
    });

    $scope.sendMessage = function(message, groups) {
        var selectedGroups = [];
        if ($scope.selectedAll) {
            var processGroups = $scope.opMsgGroups;
            for (var i = 0; i < processGroups.length; i++) {
                selectedGroups.push({ group: processGroups[i].group });
            }
        }
        else if ((groups !== undefined) && (groups !== 0)) {
            for (var i = 0; i < groups.length; i++) {
                if (typeof groups[i] === 'string') {
                    selectedGroups.push({ group: groups[i] });
                }
            }
        }
        var groupsAsJson = angular.toJson(selectedGroups);

        if (($scope.message != "") && 
            ((groups != undefined && groups != "") || $scope.selectedAll)) {
            $http({
                method: 'POST',
                url: 'abb_isapi.dll?cmd=operator_message',
                data: '{ "message":  \"' + message + '\",  "groups":' + groupsAsJson + " }",
                headers: { 'Content-Type': 'application/x-www-form-urlencoded' }
            }).success(function(data) {
                $scope.completed = "Message successfully sent.";
                $('#opMsgForm')[0].reset();
            });
        }
        else {
            $scope.completed = "Message not configured.";
            $('#opMsgForm')[0].reset();
        }
        
        // "Send Message" causes all fields on browser to be cleared - need to update fields accordingly
        $scope.selectedAll = false;
        $scope.groups = "";
        $scope.message = "";
    };
    
}

